/** @file launcher.h
 *
 *   The AQUOS Launcher
 *
 *     Copyright (c) 2005, 2006 Sharp Corporation
 *
 */

#if !defined(LAUNCHER_H)
#define LAUNCHER_H

#include <sched.h>
#include <sys/types.h>


#define USE_THREAD /**< Launcer Ȥꥢ륿ॹåɤưɤ */
#define DEBUG_PROGNAME_POSTFIX "_debug"


enum {
  MAX_NUM_OF_ARGS       = 8, 
  MAX_LENGTH_OF_COMMAND = 80,
  LAUNCHER_SCHED_POLICY  = SCHED_FIFO,
  PROGRAMS_SCHED_POLICY  = SCHED_FIFO,
};


typedef enum {
  Launch_Primary,    /**< λ¨ƥ֡, stdin = console   */
  Launch_Essential,  /**< λ¨ƥ֡, stdin = /dev/null */
  Launch_Repetitive, /**< λץκƵư,   stdin = /dev/null */
  Launch_OneShot,    /**< ưƽ,           stdin = /dev/null */
  Wait,              /**< ľ˵ưץνλԤ              */
  Sleep,             /**< ꤷÿ Launcher                   */
  Insmod,            /**< insmod ư */
} action_t;

typedef struct
{
  const action_t action;
  const char*    string;
  const char*    dbgopts;
  pid_t          pid;
} process_table_t;


static process_table_t the_proctab[] =
{
  { Insmod,           "/sbin/insmod /root/iLink/bks4shlx.o"},
  { Launch_Primary,   "/root/abs.out", " -d"},

#if defined(WITH_LNX)
  { Insmod,           "/sbin/insmod /root/IrSS/lr388b6-drv.o"},
  { Sleep,             "20"           },
  { Launch_Essential, "/root/lnx.out" },
#endif
};


#endif /* LAUNCHER_H */
